#-*- coding: utf-8 -*-
#
# Script_ARBRES_3.py



class Noeud:
    def __init__(self, x, fils_gauche=None, fils_droit=None):
        self.val = x
        self.fg = fils_gauche
        self.fd = fils_droit
   

def nouveauNoeud(x, arbre_gauche, arbre_droit):
    '''
    Créé un noeud de valeur x avec un sous arbre gauche
    et un sous arbre droit
    '''
    return Noeud(x, arbre_gauche, arbre_droit)



        
def parcoursInfixe(arbre):
    '''
    Affiche les éléments de a dans un parcours infixe
    Traiter la racine entre les sous-arbres
    '''


    
def parcoursPrefixe(arbre):
    '''
    Affiche les éléments de a dans un parcours préfixe
    Traiter la racine d'abord
    '''
    if arbre is None:
        return
    print(arbre.val)
    parcoursPrefixe(arbre.fg)
    parcoursPrefixe(arbre.fd)
    
    
def parcoursPostfixe(arbre):
    '''
    Affiche les éléments de a dans un parcours postfixe
    Traiter la racine en dernier
    '''


    

def imprimeArbreNiveau(niveau,arbre):
    '''
    Affiche les éléments de a dans un parcours préfixe
    Traiter la racine d'abord
    '''
    decalage = '---'*niveau
    if arbre is None:
        print(' ',decalage,'o')
        return
    if niveau==0:
        print(decalage,arbre.val)
    else:
        print(' ',decalage,arbre.val)        
    imprimeArbreNiveau(niveau+1,arbre.fg)
    imprimeArbreNiveau(niveau+1,arbre.fd)
    
def imprimeArbre(arbre):
    '''
    Appel de la fonction récursive d'impression des arbres
    Le niveau 0 sert à gérer les décalages successifs à 
    l'affichage
    '''
    imprimeArbreNiveau(0,arbre)


## Mise en oeuvre des parcours en profondeur        

# Création de l'exemple du cours 
'''
        A
      /   \
    B       G
   / \     / \
  C   F   H   I
 / \         /
D   E       J
'''
# Sous arbre de gauche à partir de la racine A
noeud_D = Noeud('D')
noeud_E = Noeud('E')
noeud_C = nouveauNoeud('C', noeud_D, noeud_E)
noeud_F = Noeud('F')
noeud_B = nouveauNoeud('B', noeud_C, noeud_F)

# Sous arbre de droite à partir de la racine A
noeud_J = Noeud('J')
noeud_I = nouveauNoeud('I', noeud_J , None)
noeud_H = Noeud('H')
noeud_G = nouveauNoeud('G', noeud_H, noeud_I)

# Assemblage final des deux parties
arbre_exemple_du_cours = nouveauNoeud('A', noeud_B, noeud_G)

# Tracé
print("Tracé arbre du cours")
imprimeArbre(arbre_exemple_du_cours)
print()

# Parcours préfixe
print("Parcours préfixe arbre du cours")
parcoursPrefixe(arbre_exemple_du_cours)
print()

# Parcours infixe
print("Parcours infixe arbre du cours")
parcoursInfixe(arbre_exemple_du_cours)
print()

# Parcours suffixe
print("Parcours postfixe arbre du cours")
parcoursPostfixe(arbre_exemple_du_cours)
print()


