# Script_ARBRES_4.py

class Cell:
    def __init__(self,  x):
        self.val  =  x
        self.next  =  None

class Pile:
    def __init__(self):
        self.lst  =  []
    
    def estVide(self):
        return self.lst  ==  []
    
    def empiler(self, x):
        self.lst.append(x)
    
    def depiler(self):
        if self.estVide():
            raise ValueError("pile  vide")
        return self.lst.pop()

    def afficher(self):
        """afficher le contenu de la pile"""
        imprimeElement(self.lst)


class File:
    def __init__(self):
        self.inbox  =  Pile()
        self.outbox =  Pile()
        
    def enfiler(self, x):
        self.inbox.empiler(x)
        
    def defiler(self):
        if self.estVide():
            return "Impossible file Vide"
        if self.outbox.estVide():
            while  not self.inbox.estVide():
                self.outbox.empiler(self.inbox.depiler())
        return self.outbox.depiler()
        
    def estVide(self):
        return self.inbox.estVide() and self.outbox.estVide()

class Noeud:
    def __init__(self, x, fils_gauche=None, fils_droit=None):
        self.val = x
        self.fg = fils_gauche
        self.fd = fils_droit
   

def nouveauNoeud(x, arbre_gauche, arbre_droit):
    '''
    Ajoute un noeud de valeur x à l'arbre a
    '''
    return Noeud(x, arbre_gauche, arbre_droit)


def parcoursBFS(arbre):
    '''
    Parcours BFS de l'arbre
    Utilisation d'une file.
    '''
    file = File()




 
    
def imprimeArbreNiveau(niveau,arbre):
    '''
    Affiche les éléments de a dans un parcours préfixe
    Traiter la racine d'abord
    '''
    decalage = '---'*niveau
    if arbre is None:
        print(' ',decalage,'o')
        return
    if niveau==0:
        print(decalage,arbre.val)
    else:
        print(' ',decalage,arbre.val)        
    imprimeArbreNiveau(niveau+1,arbre.fg)
    imprimeArbreNiveau(niveau+1,arbre.fd)
    
def imprimeArbre(arbre):
    '''
    Appel de la fonction récursive d'impression des arbres
    Le niveau 0 sert à gérer les décalages successifs à 
    l'affichage
    '''
    imprimeArbreNiveau(0,arbre)
        
## Création de l'exemple du cours arbres.pdf p.11
'''
        A
      /   \
    B       G
   / \     / \
  C   F   H   I
 / \         /
D   E       J
'''
# Sous arbre de gauche à partir de la racine A
noeud_D = Noeud('D')
noeud_E = Noeud('E')
noeud_C = nouveauNoeud('C', noeud_D, noeud_E)
noeud_F = Noeud('F')
noeud_B = nouveauNoeud('B', noeud_C, noeud_F)

# Sous arbre de droite à partir de la racine A
noeud_J = Noeud('J')
noeud_I = nouveauNoeud('I', noeud_J, None)
noeud_H = Noeud('H')
noeud_G = nouveauNoeud('G', noeud_H, noeud_I)

# Assemblage final des deux parties
arbre_exemple_du_cours = nouveauNoeud('A', noeud_B, noeud_G)


# Essai de tracé
print("Tracé arbre du cours")
imprimeArbre(arbre_exemple_du_cours)
print()


# Parcours en largeur BFS
print("Parcours largeur arbre du cours")
parcoursBFS(arbre_exemple_du_cours)
print()
